public class BufferWithYield implements BufferInterface {
	private final int BUFFER_SIZE = 5; private int count = 0;
	private Object buffer[] = new Object[BUFFER_SIZE];
	private int in = 0; private int out = 0;

	//put() called by producer
	public synchronized void put(Object item) {
		while (count == BUFFER_SIZE)
			Thread.yield();
		++count;
		buffer[in] = item;
		in = (in + 1) % BUFFER_SIZE;
	}

	//take() called by consumer
	public synchronized Object take() {
		Object  item;
		while (count == 0)
			Thread.yield();
		--count;
		item = buffer[out];
		out = (out + 1) % BUFFER_SIZE;
		return item;
	}
}
